"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var inquirer_1 = require("inquirer");
var path_1 = require("path");
var fs_1 = require("fs");
var compile_1 = require("./compile");
var log_1 = require("../../lib/log");
var config_1 = require("../../lib/config");
var useDefaultsPrompt = function () { return __awaiter(_this, void 0, void 0, function () {
    var prompt, responses;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                prompt = inquirer_1.createPromptModule();
                return [4 /*yield*/, prompt([{
                            type: 'confirm',
                            name: 'useDefault',
                            message: 'Do you want to use the default configuration?'
                        }])];
            case 1:
                responses = _a.sent();
                return [2 /*return*/, responses.useDefault];
        }
    });
}); };
var configPrompt = function (useDefaults) { return __awaiter(_this, void 0, void 0, function () {
    var prompt, config;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (useDefaults)
                    return [2 /*return*/, config_1.default];
                prompt = inquirer_1.createPromptModule();
                return [4 /*yield*/, prompt([
                        {
                            type: 'input',
                            name: 'appRoot',
                            message: 'appRoot:',
                            default: config_1.default.appRoot,
                        },
                        {
                            type: 'input',
                            name: 'contractsRoot',
                            message: 'contractsRoot:',
                            default: config_1.default.contractsRoot,
                        },
                        {
                            type: 'input',
                            name: 'contractsPath',
                            message: 'contractsPath:',
                            default: config_1.default.contractsPath,
                        },
                        {
                            type: 'input',
                            name: 'compiledContractsRoot',
                            message: 'compiledContractsRoot:',
                            default: config_1.default.compiledContractsRoot,
                        },
                    ])];
            case 1:
                config = _a.sent();
                return [2 /*return*/, config];
        }
    });
}); };
exports.default = function (argv) { return __awaiter(_this, void 0, void 0, function () {
    var useDefaults, config, exampleContract;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                log_1.log('Initializing Rivet...\n');
                return [4 /*yield*/, useDefaultsPrompt()];
            case 1:
                useDefaults = _a.sent();
                return [4 /*yield*/, configPrompt(useDefaults)];
            case 2:
                config = _a.sent();
                compile_1.saveToFile("module.exports = " + JSON.stringify(config, null, 2) + ";", '.rivet.config.js', config.appRoot);
                exampleContract = fs_1.readFileSync(path_1.resolve(config_1.default.pkgRoot, './example/consumer/contracts/example.contract.js'), 'utf8');
                compile_1.saveToFile(exampleContract, 'example.contract.js', config.contractsRoot);
                return [2 /*return*/];
        }
    });
}); };
