"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var colors = require("colors");
exports.textHelpers = {
    pkg: 'rivet',
    cmd: colors.green('cmd'),
    info: colors.green('info'),
    warn: colors.yellow('warn'),
    error: colors.red('error'),
};
var print = function (logger, type, message, fallbackType) {
    var msg = message || type;
    var msgType = exports.textHelpers[type] || exports.textHelpers[fallbackType || message];
    logger(exports.textHelpers.pkg + " " + msgType + " " + msg);
};
exports.log = function (type, message) { return print(process.stdout.write.bind(process.stdout), type, message, 'info'); };
exports.warn = function (type, message) { return print(process.stdout.write.bind(process.stdout), type, message, 'warn'); };
exports.error = function (type, message) { return print(process.stderr.write.bind(process.stderr), type, message, 'error'); };
